/**
  *  \file game/trnapply.h
  *
  *  (c) 2001-2016 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_TRNAPPLY_H
#define PCC_V2_GAME_TRNAPPLY_H

#include "game/trn.h"
#include "game/unpackmod.h"
#include "cpluslib/smartptr.h"

class GTurnfileApply : public GUnpackModifier {
 public:
    GTurnfileApply(Ptr<GTurnfile> trn, bool use35);
    ~GTurnfileApply();

    virtual void updateShip(TShip& ship);
    virtual void updatePlanet(TPlanet& planet);
    virtual void updateBase(TStarbase& base);
    virtual void updateGen(GGen& gen);
    virtual void finishDirectory();

 private:
    Ptr<GTurnfile> trn;

    bool use35;
    int cursor;
    GTurnfile::CommandType cursor_obj;
    int cursor_id;

    string_t tim_allies;

    void moveCursor(GTurnfile::CommandType obj, int id);
};

#endif
