/**
  *  \file ui/widget-busy.h
  *
  *  (c) 2001-2016 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_UI_WIDGET_BUSY_H
#define PCC_V2_UI_WIDGET_BUSY_H

#include "ui/ui.h"
#include "cpluslib/types.h"

/** Simple "Busy" indicator. This widget contains just a fixed text
    with a simple frame running around it, to indicate that the
    program is busy. It is intended to be displayed directly on the
    root widget, not within a window. Users should call tick()
    periodically.

    \see ProgressMonitor */
class UIBusyWidget : public UIFixedWidget {
    uint8 phase;

    long last_time;

    void drawFrame(GfxCanvas& can);
 public:
    UIBusyWidget();
    ~UIBusyWidget();

    void drawContent(GfxCanvas& can);

    void tick();
};

#endif
